<?php

use EventPortal\Domain\Admin\Models\Admin;
use EventPortal\Domain\Permission\Models\Role;
use EventPortal\Domain\User\Models\User;

/** @var \Illuminate\Database\Eloquent\Factory $factory */

$factory->define(Admin::class, function () {
    return [
        'user_id' => function () {
            return factory(User::class)->create()->id;
        },
    ];
});

$factory->state(Admin::class, 'snapshot', function () {
    return [
        'user_id' => function () {
            return factory(User::class)->state('snapshot')->create()->id;
        },
    ];
});

$factory->state(Admin::class, 'admin', function () {
    return [];
});

$factory->afterCreatingState(Admin::class, 'admin', function (Admin $admin) {
    $role = Role::findByName('admin');

    $admin->assignRole($role);
});

$factory->afterCreatingState(Admin::class, 'compliance', function (Admin $admin) {
    $role = Role::findByName('compliance');

    $admin->assignRole($role);
});


$factory->state(Admin::class, 'super-admin', function () {
    return [];
});

$factory->afterCreatingState(Admin::class, 'super-admin', function (Admin $admin) {
    $role = Role::findByName('super-admin');

    $admin->assignRole($role);
});
