<?php

use EventPortal\Domain\Component\Button;
use EventPortal\Domain\Component\Display;
use EventPortal\Domain\Component\Section;
use EventPortal\Domain\Event\Models\Event;
use EventPortal\Domain\Form\Facades\Form;
use EventPortal\Enums\InertiaMethod;

Form::make('event-venue.show')
    ->addFields(function () {
        return [
            Section::make('Key details')->fields([
                Display::make('Name'),
                Display::make('Website'),
            ]),

            Section::make('Address')->fields([
                Display::make('First line')->name('line_1')->scopeTo('address'),
                Display::make('Second line')->name('line_2')->scopeTo('address'),
                Display::make('Third line')->name('line_3')->scopeTo('address'),
                Display::make('City')->scopeTo('address'),
                Display::make('Area')->scopeTo('address'),
                Display::make('Country')->scopeTo('address'),
                Display::make('Area code')->scopeTo('address'),
            ]),
        ];
    })
    ->addActions(function (Event $event) {
        return [
            Button::make('Back')
                ->variant('secondary')
                ->route('admin.event.venue.index', $event)
                ->method(InertiaMethod::VISIT()),
        ];
    });
