<?php

namespace EventPortal\Tests\Feature\Admin\Speaker;

use EventPortal\Domain\Delegate\Models\Delegate;
use EventPortal\Domain\Speaker\Models\Speaker;
use EventPortal\Domain\User\Models\User;
use EventPortal\Tests\Support\Traits\SeedRolesAndPermissions;
use EventPortal\Tests\TestCase;
use Illuminate\Foundation\Testing\RefreshDatabase;

class CreateSpeakerFromExistingUserTest extends TestCase
{
    use RefreshDatabase, SeedRolesAndPermissions;

    /** @test */
    public function can_create_a_speaker_from_an_existing_user(): void
    {
        $delegate = factory(Delegate::class)->create();

        $this
            ->actingAsSuperAdmin()
            ->post(route('admin.speaker.store', [
                'first_name' => 'Jane',
                'last_name' => 'Doe',
                'email' => $delegate->user->email,
            ]))
            ->assertRedirect(route('admin.speaker.show', Speaker::first()->id));

        $this->assertCount(1, User::where('email', $delegate->user->email)->get());
        $this->assertCount(1, Speaker::all());
    }
}
