<?php

namespace EventPortal\Tests\Unit\Comment\Models;

use EventPortal\Domain\Comment\Models\Comment;
use EventPortal\Domain\Approval\Models\Approval;
use EventPortal\Tests\TestCase;
use Illuminate\Foundation\Testing\RefreshDatabase;

/**
 * Class CommentTest
 * @package EventPortal\Tests\Unit\Comment\Models
 * @group Comment
 */
class CommentTest extends TestCase
{
    use RefreshDatabase;

    /** @test */
    public function comment_saves_with_correct_commentable_type(): void
    {
        $comment = factory(Comment::class)->state('event_approval')->create();

        $this->assertInstanceOf(Approval::class, $comment->commentable);
    }
}
